/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024  Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//NPM imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const channelModel = require('../../../schemas/channel/channelSchema');

//api account functions
module.exports.get = async function(req, res){
    try{
        const validResult = validationResult(req);

        if(validResult.isEmpty()){
            const data = matchedData(req);
            const channel = await channelModel.findOne({name: data.chanName});

            if(channel == null){
                throw new Error("Channel not found.");
            }

            res.status(200);
            return res.send(channel.settings);
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}

module.exports.post = async function(req, res){
    try{
        const validResult = validationResult(req);

        if(validResult.isEmpty()){
            const data = matchedData(req);
            const channel = await channelModel.findOne({name: data.chanName});
            const settingsMap = new Map(Object.entries(data.settingsMap));

            if(channel == null){
                throw new Error("Channel not found.");
            }

            res.status(200);
            return res.send(await channel.updateSettings(settingsMap));
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}